#include <stdio.h>
#include <stdlib.h>

#include "queue.h"

#define MAX 10

int main(int argc, char**argv)
   {
   int i, j;
   int *ip;
   struct queue * q;

   q = queue_new(MAX);
   if (NULL == q)
      {
      perror("queue_new");
      exit(EXIT_FAILURE);
      }

   // Fill the queue
   for (i=0; i < MAX; i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      if (NULL == queue_push(q, (void *) ip))
	 {
         printf("queue_push failed\n");
	 free(ip);
	 }
      }

   // remove 5 items
   printf("queue size is %zd\n", queue_size(q));
   for (j=0; j < 5 && NULL != (ip = queue_pop(q)); j++)
      {
      printf("%d\n", *ip);
      free(ip);
      }
   printf("queue size is %zd\n", queue_size(q));

   // Overfill the queue
   for (i=MAX; i < 2*MAX; i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      if (NULL == queue_push(q, (void *) ip))
	 {
         printf("queue_push failed\n");
	 free(ip);
	 }
      }

   // Empty the queue
   printf("queue size is %zd\n", queue_size(q));
   while (NULL != (ip = queue_pop(q)))
      {
      printf("%d\n", *ip);
      free(ip);
      }
   printf("queue size is %zd\n", queue_size(q));

   queue_delete(q);

   exit(EXIT_SUCCESS);
   }
